//                         MACD-combine.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
 
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Silver
//---- input parameters
extern int       ExtFastEMA=12;
extern int       ExtSlowEMA=26;
extern int       ExtSignalSMA=9;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer3);
//----
   SetIndexDrawBegin(1,ExtSignalSMA);
   SetIndexDrawBegin(2,ExtSignalSMA);
   IndicatorDigits(Digits+2);
   IndicatorShortName("MACD-combo("+ExtFastEMA+","+ExtSlowEMA+","+ExtSignalSMA+")");
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
   SetIndexLabel(2,"OsMA");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd
   for(int i=0; i<limit; i++)
      ExtMapBuffer1[i]=iMA(NULL,0,ExtFastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,ExtSlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
//---- signal
   for(i=0; i<limit; i++)
      ExtMapBuffer2[i]=iMAOnArray(ExtMapBuffer1,Bars,ExtSignalSMA,0,MODE_SMA,i);
//---- osma
   for(i=0; i<limit; i++)
      ExtMapBuffer3[i]=ExtMapBuffer1[i]-ExtMapBuffer2[i];
//---- done
   return(0);
  }
//+------------------------------------------------------------------+